<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "directory_partner_layout".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "DirectoryPartnerLayout".
 *
 * Columns in table "directory_partner_layout" available as properties of the model,
 * followed by relations of table "directory_partner_layout" available as properties of the model.
 *
 * @property integer $id
 * @property integer $directory_setting_id
 * @property string $layout_components
 * @property integer $order
 * @property integer $directory_component_template_id
 * @property integer $component_section_id
 * @property string $style_variables
 * @property string $texts_and_placeholders
 *
 * @property DirectoryComponentSection $componentSection
 * @property DirectorySetting $directorySetting
 */
abstract class BaseDirectoryPartnerLayout extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'directory_partner_layout';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'DirectoryPartnerLayout|DirectoryPartnerLayouts', $n);
    }

    public static function representingColumn()
    {
        return 'layout_components';
    }

    public function rules()
    {
        return array(
            array('directory_setting_id', 'required'),
            array('directory_setting_id, order, directory_component_template_id, component_section_id', 'numerical', 'integerOnly'=>true),
            array('layout_components, style_variables, texts_and_placeholders', 'safe'),
            array('layout_components, order, directory_component_template_id, component_section_id, style_variables, texts_and_placeholders', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, directory_setting_id, layout_components, order, directory_component_template_id, component_section_id, style_variables, texts_and_placeholders', 'safe', 'on'=>'search'),
        );
    }

    public function relations()
    {
        return array(
            'componentSection' => array(self::BELONGS_TO, 'DirectoryComponentSection', 'component_section_id'),
            'directorySetting' => array(self::BELONGS_TO, 'DirectorySetting', 'directory_setting_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'directory_setting_id' => null,
            'layout_components' => Yii::t('app', 'Layout Components'),
            'order' => Yii::t('app', 'Order'),
            'directory_component_template_id' => Yii::t('app', 'Directory Component Template'),
            'component_section_id' => null,
            'style_variables' => Yii::t('app', 'Style Variables'),
            'texts_and_placeholders' => Yii::t('app', 'Texts And Placeholders'),
            'componentSection' => null,
            'directorySetting' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('directory_setting_id', $this->directory_setting_id);
        $criteria->compare('layout_components', $this->layout_components, true);
        $criteria->compare('order', $this->order);
        $criteria->compare('directory_component_template_id', $this->directory_component_template_id);
        $criteria->compare('component_section_id', $this->component_section_id);
        $criteria->compare('style_variables', $this->style_variables, true);
        $criteria->compare('texts_and_placeholders', $this->texts_and_placeholders, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria, 'pagination' => array('pageSize' => 100)
        ));
    }

}
